/*! *****************************************************************************
MIT License

Copyright (c) 2022-Present js-pack

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
***************************************************************************** */

import { jsx, Fragment } from 'react/jsx-runtime';
import React, {
  useRef,
  useState,
  useCallback,
  useEffect,
  useContext,
  useMemo,
} from 'react';
import jwtDecode from 'jwt-decode';
var __assign = function () {
  __assign =
    Object.assign ||
    function __assign(t) {
      for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s)
          if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
      return t;
    };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s)
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
      t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === 'function')
    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
      if (
        e.indexOf(p[i]) < 0 &&
        Object.prototype.propertyIsEnumerable.call(s, p[i])
      )
        t[p[i]] = s[p[i]];
    }
  return t;
}
function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P
      ? value
      : new P(function (resolve) {
          resolve(value);
        });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator['throw'](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done
        ? resolve(result.value)
        : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __generator(thisArg, body) {
  var _ = {
      label: 0,
      sent: function () {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: [],
    },
    f,
    y,
    t,
    g;
  return (
    (g = { next: verb(0), throw: verb(1), return: verb(2) }),
    typeof Symbol === 'function' &&
      (g[Symbol.iterator] = function () {
        return this;
      }),
    g
  );
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError('Generator is already executing.');
    while (_)
      try {
        if (
          ((f = 1),
          y &&
            (t =
              op[0] & 2
                ? y['return']
                : op[0]
                ? y['throw'] || ((t = y['return']) && t.call(y), 0)
                : y.next) &&
            !(t = t.call(y, op[1])).done)
        )
          return t;
        if (((y = 0), t)) op = [op[0] & 2, t.value];
        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;
          case 4:
            _.label++;
            return { value: op[1], done: false };
          case 5:
            _.label++;
            y = op[1];
            op = [0];
            continue;
          case 7:
            op = _.ops.pop();
            _.trys.pop();
            continue;
          default:
            if (
              !((t = _.trys), (t = t.length > 0 && t[t.length - 1])) &&
              (op[0] === 6 || op[0] === 2)
            ) {
              _ = 0;
              continue;
            }
            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
              _.label = op[1];
              break;
            }
            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }
            if (t && _.label < t[2]) {
              _.label = t[2];
              _.ops.push(op);
              break;
            }
            if (t[2]) _.ops.pop();
            _.trys.pop();
            continue;
        }
        op = body.call(thisArg, _);
      } catch (e) {
        op = [6, e];
        y = 0;
      } finally {
        f = t = 0;
      }
    if (op[0] & 5) throw op[1];
    return { value: op[0] ? op[1] : void 0, done: true };
  }
}
var AuthContext = React.createContext({
  user: {},
  userPermissions: [],
  userPermissionsAreSet: false,
  setUser: function () {},
  isAuth: false,
  redirectToLogin: function () {},
  pageAttempt: '/',
});
AuthContext.displayName = 'AuthContext';
var TOKEN_KEY = 'token';
var REFRESH_TOKEN_KEY = 'refresh-token';
var getToken = function () {
  var _a;
  return (_a = localStorage.getItem(
    process.env.REACT_APP_REACT_AUTH_TOKEN_KEY || TOKEN_KEY
  )) !== null && _a !== void 0
    ? _a
    : '';
};
var getRefreshToken = function () {
  var _a;
  return (_a = localStorage.getItem(
    process.env.REACT_APP_REACT_AUTH_TOKEN_KEY || REFRESH_TOKEN_KEY
  )) !== null && _a !== void 0
    ? _a
    : '';
};
var setToken = function (token) {
  return (
    token &&
    localStorage.setItem(
      process.env.REACT_APP_REACT_AUTH_TOKEN_KEY || TOKEN_KEY,
      token
    )
  );
};
var setRefreshToken = function (refreshToken) {
  return (
    refreshToken &&
    localStorage.setItem(
      process.env.REACT_APP_REACT_AUTH_TOKEN_KEY || REFRESH_TOKEN_KEY,
      refreshToken
    )
  );
};
var removeToken = function () {
  return localStorage.removeItem(
    process.env.REACT_APP_REACT_AUTH_TOKEN_KEY || TOKEN_KEY
  );
};
var removeRefreshToken = function () {
  return localStorage.removeItem(
    process.env.REACT_APP_REACT_AUTH_TOKEN_KEY || REFRESH_TOKEN_KEY
  );
};
var isTokenExpired = function (token) {
  try {
    var tokenInfo = jwtDecode(token);
    return new Date() >= new Date(tokenInfo.exp * 1e3);
  } catch (error) {
    return true;
  }
};
var isAuthenticated = function () {
  return !isTokenExpired(getToken());
};
var redirectTo = function (to) {
  window.location.replace(to);
};
var redirectToLogin = function (loginPath) {
  if (!window.location.pathname.includes(loginPath)) {
    removeToken();
    removeRefreshToken();
    redirectTo(
      ''
        .concat(loginPath, '?attempt=')
        .concat(
          encodeURIComponent(window.location.pathname + window.location.search)
        )
    );
  }
};
var getUser = function (_a) {
  var tokenProp = _a.token;
  return __awaiter(void 0, void 0, void 0, function () {
    var token, user;
    return __generator(this, function (_b) {
      try {
        setToken(tokenProp);
        token = getToken();
        user = jwtDecode(token);
        return [2, __assign(__assign({}, user), { token: token })];
      } catch (error) {
        return [2, {}];
      }
      return [2];
    });
  });
};
var getPropFromToken = function (token, propName) {
  var decodedToken;
  try {
    decodedToken = jwtDecode(token);
  } catch (error) {
    decodedToken = {};
  }
  return decodedToken[propName];
};
var getUrlParameterByName = function (name, url) {
  var cleanName = name.replace(/[\[\]]/g, '\\$&');
  var regex = new RegExp('[?&]'.concat(cleanName, '(=([^&#]*)|&|#|$)'));
  var results = regex.exec(url);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, ' '));
};
var getPageAttempt = function (url) {
  var _a;
  return (_a = getUrlParameterByName('attempt', url)) !== null && _a !== void 0
    ? _a
    : '/';
};
var BUFFER_MS = 12e4;
var defaultPermissionsParser = function (user) {
  return user === null || user === void 0 ? void 0 : user.permissions;
};
var defaultUserExtender = function (user) {
  return user;
};
var defaultTokenReFetcher = function () {
  return Promise.resolve({ token: '', refreshToken: '' });
};
var AuthProvider = function (_a) {
  var children = _a.children,
    anonymousRoutes = _a.anonymousRoutes,
    _b = _a.enableRedirectToLogin,
    enableRedirectToLogin = _b === void 0 ? false : _b,
    _c = _a.redirectToLoginPath,
    redirectToLoginPath = _c === void 0 ? '' : _c,
    _d = _a.permissionParser,
    permissionParser = _d === void 0 ? defaultPermissionsParser : _d,
    _e = _a.userExtender,
    userExtender = _e === void 0 ? defaultUserExtender : _e,
    _f = _a.tokenReFetcher,
    tokenReFetcher = _f === void 0 ? defaultTokenReFetcher : _f;
  var refreshTokenTimerRef = useRef();
  var _g = useState({}),
    user = _g[0],
    _setUser = _g[1];
  var _h = useState([]),
    userPermissions = _h[0],
    setUserPermissions = _h[1];
  var _j = useState(false),
    userPermissionsAreSet = _j[0],
    setUserPermissionsAreSet = _j[1];
  var isAuth = isAuthenticated();
  var authGuard = useCallback(
    function (e) {
      var _a;
      if (
        enableRedirectToLogin &&
        !isAuthenticated() &&
        !(
          anonymousRoutes !== null && anonymousRoutes !== void 0
            ? anonymousRoutes
            : []
        )
          .map(function (_a) {
            var path = _a.path;
            return path;
          })
          .includes(window.location.pathname)
      ) {
        (_a = e === null || e === void 0 ? void 0 : e.stopPropagation) ===
          null || _a === void 0
          ? void 0
          : _a.call(e);
        redirectToLogin(redirectToLoginPath);
      }
    },
    [anonymousRoutes]
  );
  var setUser = function (_a) {
    var tokenProp = _a.token,
      refreshTokenProp = _a.refreshToken;
    return __awaiter(void 0, void 0, void 0, function () {
      var newUser, permissions;
      return __generator(this, function (_b) {
        switch (_b.label) {
          case 0:
            _b.trys.push([0, 4, , 5]);
            if (refreshTokenProp) {
              setRefreshToken(refreshTokenProp);
            }
            newUser = {};
            if (!tokenProp) return [3, 3];
            return [4, getUser({ token: tokenProp })];
          case 1:
            newUser = _b.sent();
            return [4, userExtender(newUser)];
          case 2:
            newUser = _b.sent();
            _b.label = 3;
          case 3:
            if (newUser === null || newUser === void 0 ? void 0 : newUser.exp) {
              _setUser(newUser);
              permissions = permissionParser(newUser);
              if (
                permissionParser !== defaultPermissionsParser &&
                !permissions
              ) {
                console.error(
                  'Permissions may be set incorrectly, check permissionsParser prop to use Permit component properly'
                );
              }
              setUserPermissions(Array.isArray(permissions) ? permissions : []);
            }
            setUserPermissionsAreSet(true);
            return [3, 5];
          case 4:
            _b.sent();
            setUserPermissionsAreSet(true);
            return [3, 5];
          case 5:
            return [2];
        }
      });
    });
  };
  var startRefreshTokenTimer = useCallback(function (
    currentToken,
    currentRefreshToken
  ) {
    if (
      currentToken &&
      currentRefreshToken &&
      !isTokenExpired(currentRefreshToken)
    ) {
      clearTimeout(refreshTokenTimerRef.current);
      var expires = getPropFromToken(currentToken, 'exp') * 1e3;
      var timeout = expires - Date.now() - BUFFER_MS;
      refreshTokenTimerRef.current = setTimeout(function () {
        refetchToken(currentRefreshToken);
      }, timeout);
    }
  },
  []);
  var refetchToken = useCallback(
    function (currentRefreshToken) {
      var _a;
      var resolvable =
        (_a =
          tokenReFetcher === null || tokenReFetcher === void 0
            ? void 0
            : tokenReFetcher(currentRefreshToken)) !== null && _a !== void 0
          ? _a
          : defaultTokenReFetcher();
      resolvable.then(function (_a) {
        var token = _a.token,
          refreshToken = _a.refreshToken;
        setUser({ token: token, refreshToken: refreshToken });
        startRefreshTokenTimer(token, refreshToken);
      });
    },
    [tokenReFetcher]
  );
  var redirect = useCallback(
    function () {
      return redirectToLogin(redirectToLoginPath);
    },
    [redirectToLoginPath]
  );
  useEffect(function () {
    var token = getToken();
    var refreshToken = getRefreshToken();
    if (!isAuth && !isTokenExpired(refreshToken)) {
      refetchToken(refreshToken);
    }
    if (!user.exp && isAuth) {
      setUser({ token: token, refreshToken: refreshToken });
    }
    startRefreshTokenTimer(token, refreshToken);
    if (enableRedirectToLogin) {
      window.removeEventListener('mousedown', authGuard);
      window.addEventListener('mousedown', authGuard);
      window.removeEventListener('keydown', authGuard);
      window.addEventListener('keydown', authGuard);
    }
    return function () {
      clearTimeout(refreshTokenTimerRef.current);
      window.removeEventListener('mousedown', authGuard);
      window.removeEventListener('keydown', authGuard);
    };
  }, []);
  return jsx(
    AuthContext.Provider,
    __assign(
      {
        value: {
          user: user,
          userPermissions: userPermissions,
          userPermissionsAreSet: userPermissionsAreSet,
          setUser: setUser,
          get isAuth() {
            return isAuthenticated();
          },
          redirectToLogin: redirect,
          get pageAttempt() {
            return getPageAttempt(window.location.search);
          },
        },
      },
      { children: children }
    )
  );
};
var useAuth = function () {
  return useContext(AuthContext);
};
var useHasPermissions = function (initialHas) {
  if (initialHas === void 0) {
    initialHas = [];
  }
  var userPermissions = useAuth().userPermissions;
  var hasPermissions = useCallback(
    function (has) {
      if (has === void 0) {
        has = initialHas;
      }
      return has.every(userPermissions.includes);
    },
    [userPermissions]
  );
  return hasPermissions;
};
var useOneOfPermissions = function (initialHas) {
  if (initialHas === void 0) {
    initialHas = [];
  }
  var userPermissions = useAuth().userPermissions;
  var hasOneOfPermissions = useCallback(
    function (has) {
      if (has === void 0) {
        has = initialHas;
      }
      return has.some(userPermissions.includes);
    },
    [userPermissions]
  );
  return hasOneOfPermissions;
};
var Permit = function (_a) {
  var condition = _a.condition,
    oneOf = _a.oneOf,
    has = _a.has,
    or = _a.or,
    children = _a.children,
    rest = __rest(_a, ['condition', 'oneOf', 'has', 'or', 'children']);
  var _b = useAuth(),
    userPermissions = _b.userPermissions,
    userPermissionsAreSet = _b.userPermissionsAreSet;
  var visible = useMemo(
    function () {
      if (!userPermissionsAreSet) {
        return false;
      } else {
        var isVisible = true;
        isVisible = (has !== null && has !== void 0 ? has : []).reduce(
          function (accm, value) {
            return accm && userPermissions.includes(value);
          },
          isVisible
        );
        isVisible = (oneOf !== null && oneOf !== void 0 ? oneOf : []).reduce(
          function (accm, value) {
            return (
              accm ||
              !!(oneOf === null || oneOf === void 0
                ? void 0
                : oneOf.includes(value))
            );
          },
          !(oneOf === null || oneOf === void 0 ? void 0 : oneOf.length) &&
            isVisible
        );
        return (
          isVisible &&
          (condition === null || condition === void 0 ? void 0 : condition())
        );
      }
    },
    [oneOf, has, userPermissions, userPermissionsAreSet, condition]
  );
  var resultElement = null;
  if (userPermissionsAreSet) {
    if (visible) {
      resultElement = children
        ? React.Children.map(children, function (child) {
            return (
              child &&
              React.cloneElement(
                child,
                __assign(__assign({}, child.props), rest)
              )
            );
          })
        : children;
    } else if (or) {
      resultElement = or;
    }
  }
  return jsx(Fragment, { children: resultElement });
};
Permit.defaultProps = {
  condition: function () {
    return true;
  },
  oneOf: [],
  has: [],
};
export {
  AuthProvider,
  Permit,
  useAuth,
  useHasPermissions,
  useOneOfPermissions,
};
